Package: SBMLR
Title: SBML-R Interface and Analysis Tools
Version: 2.8.0
Date: 2022-03-28
Author: Tomas Radivoyevitch, Vishak Venkateswaran
Description: This package contains a systems biology markup language
        (SBML) interface to R.
Maintainer: Tomas Radivoyevitch <radivot@gmail.com>
Depends: XML, deSolve
Suggests: rsbml
License: GPL-2
URL: http://epbi-radivot.cwru.edu/SBMLR/SBMLR.html
biocViews: GraphAndNetwork, Pathways, Network
git_url: https://git.bioconductor.org/packages/SBMLR
git_branch: RELEASE_3_23
git_last_commit: d915c8a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:22:58 UTC; biocbuild
Built: R 4.6.0; ; 2026-04-29 19:32:17 UTC; unix

Although I update these files (for the first time since 2005) to use sim() instead of simulate(), 
these codes depend on R data packages that I once maintained but no longer do. 
As such, I'm keeping this code here just so I can look
back at the source if I need to, i.e. I'm no longer maintaining these files
as an example of reproducible research. 

# This script, curtoNatural.R, shows how Curto's model
# might be implemented in R naturally (without knowledge of SBML).
library(deSolve)

# first define the powers f of the rate laws 
fada4 =0.97; fade6 =0.55; fadrnr4 =0.1; fadrnr9 =-0.3
fadrnr10=0.87; fampd4 =0.8; fampd8 =-0.03; fampd18 =-0.1
faprt1 =0.5; faprt4 =-0.8; faprt6 =0.75; fasuc2 =0.4
fasuc4 =-.24; fasuc8 =0.2; fasuc18 =-.05; fasli3 =0.99
fasli4 =-.95; fdada9 =1; fden1 =2; fden2 =-.06
fden4 =-.25; fden8 =-.2; fden18 =-.08; fdgnuc10=1
fdnan12=1; fdnap9 =0.42; fdnap10 =0.33; fgdrnr8 =0.4
fgdrnr9 =-1.2; fgdrnr10=-.39; fgmpr2 =-.15; fgmpr4 =-.07
fgmpr7 =-.76; fgmpr8 =0.7; fgmps4 =0.12; fgmps7 =0.16
fgnuc8 =0.9; fgnuc18 =-.34; fgprt1 =1.2; fgprt8 =-1.2
fgprt15 =0.42; fgua15 =0.5; fhprt1 =1.1; fhprt2 =-.89
fhprt13 =0.48; fhx13 =1.12; fhxd13 =0.65; fimpd2 =0.15
fimpd7 =-.09; fimpd8 =-.03; finuc2 =0.8; finuc18 =-.36
fmat4=0.2; fmat5=-.6; fpolyam5=0.9; fprpps1 =-.03
fprpps4 =-.45; fprpps8 =-.04; fprpps17=0.65; fprpps18 =0.7
fpyr1 =1.27; frnan11 =1; frnap4 =0.05; frnap8 =0.13
ftrans5 =0.33; fua16 =2.21; fx14 =2.0; fxd14 =0.55

# now define the rate law amplitude parameters
aada =0.001062; aade =0.01; aadna=3.2789; aadrnr =0.0602
aampd =0.02688; aaprt =233.8; aarna =614.5; aasuc =3.5932
aasli =66544; adada =0.03333; aden =5.2728; adgnuc=0.03333
adnaa =0.001938; adnag =0.001318; agdna=2.2296; agdrnr =0.1199
agmpr =0.3005; agmps=0.3738; agnuc=0.2511; agprt =361.69
agrna =409.6; agua =0.4919; ahprt =12.569; ahx =0.003793
ahxd =0.2754; aimpd =1.2823; ainuc =0.9135; amat =7.2067
apolyam=0.29; aprpps=0.9; apyr =1.2951; arnaa =0.06923
arnag =0.04615; atrans =8.8539; aua =0.00008744; ax =0.0012;axd =0.949

# now define the two boundary conditions
R5P=18; Pi=1400;

# yes, it would be better to stick all of the above in p and pass directly
# rather than globally as is being done here. 

# Now define the ODE right hand side
fpur <- function(t, X, p)
{ # first define the fluxes
  vada =aada * X[4]^fada4;
  vade =aade * X[6]^fade6;
  vadna =aadna * X[9]^fdnap9 * X[10]^fdnap10;
  vadrnr =aadrnr * X[4]^fadrnr4 * X[9]^fadrnr9 * X[10]^fadrnr10;
  vampd =aampd * X[4]^fampd4 * X[8]^fampd8 * Pi^fampd18;
  vaprt =aaprt * X[1]^faprt1 * X[4]^faprt4 * X[6]^faprt6;
  varna =aarna * X[4]^frnap4* X[8]^frnap8;
  vasuc =aasuc * X[2]^fasuc2 * X[4]^fasuc4 * X[8]^fasuc8 * Pi^fasuc18;
  vasli =aasli * X[3]^fasli3 * X[4]^fasli4;
  vdada =adada * X[9]^fdada9;
  vden =aden * X[1]^fden1 * X[2]^fden2 * X[4]^fden4 * X[8]^fden8 * Pi^fden18;
  vdgnuc =adgnuc * X[10]^fdgnuc10;
  vdnaa =adnaa * X[12]^fdnan12;
  vdnag =adnag * X[12]^fdnan12;
  vgdna =agdna * X[9]^fdnap9 * X[10]^fdnap10;
  vgdrnr =agdrnr * X[8]^fgdrnr8 * X[9]^fgdrnr9 * X[10]^fgdrnr10;
  vgmpr =agmpr * X[2]^fgmpr2 * X[4]^fgmpr4 * X[7]^fgmpr7 * X[8]^fgmpr8;
  vgmps =agmps * X[4]^fgmps4 * X[7]^fgmps7;
  vgnuc =agnuc * X[8]^fgnuc8 * Pi^fgnuc18;
  vgprt =agprt * X[1]^fgprt1 * X[8]^fgprt8* X[15]^fgprt15;
  vgrna =agrna * X[8]^frnap8* X[4]^frnap4;
  vgua =agua * X[15]^fgua15;
  vhprt =ahprt * X[1]^fhprt1 * X[2]^fhprt2 * X[13]^fhprt13;
  vhx =ahx * X[13]^fhx13;
  vhxd =ahxd * X[13]^fhxd13;
  vimpd =aimpd * X[2]^fimpd2 * X[7]^fimpd7 * X[8]^fimpd8;
  vinuc =ainuc * X[2]^finuc2 * Pi^finuc18;
  vmat =amat * X[4]^fmat4 * X[5]^fmat5;
  vpolyam=apolyam* X[5]^fpolyam5;
  vprpps =aprpps * X[1]^fprpps1 * X[4]^fprpps4 * X[8]^fprpps8 * R5P^fprpps17 * Pi^fprpps18;
  vpyr =apyr * X[1]^fpyr1;
  vrnaa =arnaa * X[11]^frnan11;
  vrnag =arnag * X[11]^frnan11;
  vtrans =atrans * X[5]^ftrans5;
  vua =aua * X[16]^fua16;
  vx =ax * X[14]^fx14;
  vxd =axd * X[14]^fxd14;
  # now define dX/dt (Xi prime) as fluxes into a node minus fluxes out
  X1p = vprpps-vgprt-vhprt-vaprt-vden-vpyr;
  X2p = vden+vgmpr+vhprt+vampd-vimpd-vasuc-vinuc;
  X3p = vasuc-vasli;
  X4p = vaprt+vasli+vtrans+vrnaa-vmat-vampd-varna-vadrnr-vada;
  X5p = vmat-vtrans-vpolyam;
  X6p = vpolyam-vaprt-vade;
  X7p = vimpd-vgmps;
  X8p = vgmps+vrnag+vgprt-vgmpr-vgrna-vgdrnr-vgnuc;
  X9p = vadrnr+vdnaa-vadna-vdada;
  X10p= vgdrnr+vdnag-vgdna-vdgnuc;
  X11p= varna+vgrna-vrnaa-vrnag;
  X12p= vgdna+vadna-vdnaa-vdnag;
  X13p= vdada+vada+vinuc-vhprt-vhxd-vhx;
  X14p= vhxd+vgua-vxd-vx;
  X15p= vgnuc+vdgnuc-vgua-vgprt;
  X16p= vxd-vua;
  XP = c(X1p, X2p, X3p, X4p, X5p, X6p, X7p, X8p, X9p, X10p, X11p, X12p, X13p, X14p, X15p, X16p);
  V=c(vada,vade,vadna,vadrnr,vampd,vaprt,varna,vasuc,vasli,vdada,vden,vdgnuc,vdnaa,
      vdnag,vgdna,vgdrnr,vgmpr,vgmps,vgnuc,vgprt,vgrna,vgua,vhprt,vhx,vhxd,vimpd,
      vinuc,vmat,vpolyam, vprpps,vpyr,vrnaa,vrnag,vtrans,vua,vx,vxd)
  names(V)<-c("vada","vade","vadna","vadrnr","vampd","vaprt","varna","vasuc","vasli",
              "vdada","vden","vdgnuc","vdnaa","vdnag","vgdna","vgdrnr","vgmpr","vgmps",
              "vgnuc","vgprt","vgrna","vgua","vhprt","vhx","vhxd","vimpd",
      "vinuc","vmat","vpolyam","vprpps","vpyr","vrnaa","vrnag","vtrans","vua","vx","vxd")
  list(XP,V)
}

(y0=c(PRPP=5,IMP=100,SAMP=.2,Ado=2500,SAM=4,Ade=1,XMP=25,GMP=400,dAdo=6,
      dGMP=3,RNA=28600,DNA=5160,HX=10,Xa=5,Gua=5,UA=100))
(dPRPP10 <- data.frame(var = "PRPP", time = 0, value = 10,method = "mult"))
(out=ode(y=y0,times=seq(-20,70,1),fpur,events = list(data = dPRPP10) ) )
graphics.off()
windows(height=8,width=10,xpos=-100)
plot(out,which=c("PRPP","vden","IMP","HX","Gua","vaprt","XMP","Xa","UA"))
# The PRPP bolus pushed both de novo and salvage purine synthesis. Additional de
# novo in the end means additional uric acid coming out, i.e. UA AUC above 
# baseline is greater than the initial drop below baseline. Note also that lags
# increase with distance from the PRPP perturbation point.

# plot(out)

# show that it really did kick PRPP by a factor of 10
t(ode(y=y0,times=seq(-2,2,.5),fpur, events = list(data = dPRPP10) )[,1:2])
t(ode(y=y0,times=seq(-.5,.5,.1),fpur, events = list(data = dPRPP10) )[,1:2])
t(ode(y=y0,times=seq(-.05,.05,.01),fpur, events = list(data = dPRPP10) )[,1:2])

library(SBMLR)
# Axel Kowald's model in "A systems biological analysis links ROS metabolism to 
# mitochondrial protein quality control" Mechanisms of Ageing and Development
# 133 (2012) 331–337
# This was redrawn in JDesigner from Axel's CellDesigner original
sod=readSBML(file.path(system.file(package="SBMLR"), "models/sod2012JD.xml"))  
# Note that JD puts all params in global list
summary(sod)$V0
summary(sod)$globalVec
SOD=10^seq(-7,-3,0.2)
out=NULL
for (i in SOD) {
  sod$globalParameters$O2detox_SOD=i
  (out=rbind(out,sim(sod,times=seq(0,5) )[6,c("O2rad","H2O2")] ))
}
(df=as.data.frame(cbind(SOD,out)))
par(mfrow=c(2,1))
with(df,plot(SOD,O2rad,log="x",type="l"))
with(df,plot(SOD,H2O2,log="x",type="l"))
par(mfrow=c(1,1))

####################
library(SBMLR)
setwd("/Users/radivot/Downloads/SB/sod")
sod=readSBML("sod2012JD.xml") 

# these were both zero for Fig. 2, set here now for Fig. 3
sod$globalParameters$PRXoxidation_k9=80  
sod$globalParameters$CLPPoxidation_k13=300

SOD=10^seq(-6,-3,0.2)
Tss=1e5
out=NULL
for (i in SOD) {
  sod$globalParameters$O2detox_SOD=i
  (out=rbind(out,sim(sod,times=seq(0,Tss,by=Tss/10) )[11,c("PRX","CLPP")] ))
}
(df=as.data.frame(cbind(SOD,out)))  # shape is right, but not enough movement?????
par(mfrow=c(2,1))
with(df,plot(SOD,PRX,log="x",type="l"))
with(df,plot(SOD,CLPP,log="x",type="l"))
par(mfrow=c(1,1)) 


####################  Reproduce top curves in Figures 4a and b
library(SBMLR)
setwd("/Users/radivot/Downloads/SB/sod")
sod=readSBML("sod2012JD.xml") 
summary(sod)
paraQ=seq(0,1.3e-6,0.1e-6)
Tss=1e5
out=NULL
for (i in paraQ) {
  sod$species$paraquat$ic=i
  (out=rbind(out,sim(sod,times=seq(0,Tss,by=Tss/10) )[11,c("O2rad","H2O2")]))
}
(df=as.data.frame(cbind(paraQ,out)))  # shape is right, but not enough movement?????
with(df,plot(paraQ,H2O2,type="l",ylim=c(0,7e-7)))

sod$globalParameters$PRXoxidation_k9=80  
sod$globalParameters$CLPPoxidation_k13=300
out=NULL
for (i in paraQ) {
  sod$species$paraquat$ic=i
  (out=rbind(out,sim(sod,times=seq(0,Tss,by=Tss/10) )[11,"H2O2",drop=F]))
}
(df=as.data.frame(cbind(paraQ,out)))  
with(df,lines(paraQ,H2O2)) # note, plot on the bottom if from Fig. 4a, not lower in 4b

out=NULL
sod$globalParameters$O2detox_SOD=1e-6
for (i in paraQ) {
  sod$species$paraquat$ic=i
  (out=rbind(out,sim(sod,times=seq(0,Tss,by=Tss/10) )[11,"H2O2",drop=F]))
}
(df=as.data.frame(cbind(paraQ,out)))  
with(df,lines(paraQ,H2O2,col="red")) # here red is lower curve in 4b

# install.packages("gglot2") # not available for R 3.0.1??????
# library(gglot2)

setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
#setwd("C:/cwru/active/Morrison")  # set this to where figs should be dumped, with comment removed
load("FmorrRand.Rdata") 
DF=flux[,c("MTHFD","TYMS")]
attach(DF)
plot(TYMS,MTHFD/2, pch=1,xlab="dTMP Flux (uM/hr)",ylab="DNPS Flux (uM/hr)",ylim=c(0,1300),xlim=c(0,14))
title(main="Random",line=1,cex.main = 1,   font.main= 3, col.main= "black")
x=DF
r <- cor.test(x[,1], x[,2])
txt1 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1300, txt1, col=2,cex = .7,pos=4)
detach(DF)
dev.copy(pdf,file="fig6rand.pdf", width = 6, height = 6)
dev.off()

# This is Morrison's folate model driven by Yoeh et al also in [M.E. Ross et al, Blood (2003)]
library(Biobase)
library(annotate)
library(hgu95av2)
library(SBMLR)  
setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
morr=readSBMLR(file.path(system.file(package="SBMLR"), "models/morrison.r"))  
library(rossEset)
pD=subset(pData(ross),subset=(type=="TEL.AML1")|(type=="T.Cell")|(type=="BCR.ABL"))
pD$type=factor(pD$type, levels=c("BCR.ABL","TEL.AML1","T.Cell"))
pD$type
as.numeric(pD$type)
I=order(pD$type)
pD=pD[I,]
summary(pD$type)

library(yeoh5Eset)
eset=yeoh5[,rownames(pD)]
eset
pD
pData(eset)

morrsym=c('MTHFD1','GART','ATIC','TYMS','DHFR')
morrsym=c('SHMT1','MTHFR','MTR','MTHFD1','GART','ATIC','TYMS','DHFR')
key=c(GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")
key=c(MTHFR="MTHFR",MTR="MTR",SHMT="SHMT1",SHMTr="SHMT1",GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")

AffyID<- ls(env = hgu95av2SYMBOL)
lsym <- mget(AffyID, env = hgu95av2SYMBOL)
sym <- as.character(lsym)
names(sym)=names(lsym)
mID=names(sort(sym[is.element(sym,morrsym)]))
msym=as.character(mget(mID, env = hgu95av2SYMBOL))
(folate <- eset[mID, ])
mykp <- function(y) kruskal.test(y, pD$type)$p.value
om <- esApply(folate[mID,], 1, mean) 
tam <- esApply(folate[mID,folate$type=="TEL.AML1" ], 1, mean) 
tm <- esApply(folate[mID,folate$type=="T.Cell" ], 1, mean)
bam <- esApply(folate[mID,folate$type=="BCR.ABL" ], 1, mean)
pvals <- esApply(folate, 1, mykp)
outdat=data.frame(ID=mID,sym=msym,tam,bam,tm,om,pvals)#[om>500,]#[pvals<.05,] 
outdat  # dump out the table

counts=summary(outdat$sym)
noutdat=data.frame(NULL)
k=1
for (j in 1:length(counts)) 
   {
   kw=outdat$om[k:(k+counts[j]-1)]
   noutdat=rbind(noutdat,outdat[k+which(kw==max(kw))-1, ]    )
#   kw=outdat$pvals[k:(k+counts[j]-1)]
#   noutdat=rbind(noutdat,outdat[k+which(kw==min(kw))-1, ]    )
k=k+counts[j]
   }
k
row.names(noutdat)<-noutdat$sym
noutdat=noutdat[morrsym,]


write.table(noutdat,"table1Ross.csv",sep=",",row.names=F)
sID=as.character(noutdat$ID)
sfolate <- folate[sID, ]  # no doubles in sfolate 

gpeset=NULL
gpeset=exprs(sfolate)
row.names(gpeset)<-morrsym
DF=cbind(as.data.frame(t(gpeset)))


panel.hist <- function(x, ...)   {usr <- par("usr"); on.exit(par(usr))
 par(usr = c(usr[1:2], 0, 3) )
         h <- hist(x[cols==2], plot = FALSE)  # diagnosis
         breaks <- h$breaks; nB <- length(breaks)
         y <- h$counts; y <- y/max(y)
         lines(breaks[-nB], y, col=2, ...) 
         h <- hist(x[cols==3], plot = FALSE)  # diagnosis
         breaks <- h$breaks; nB <- length(breaks)
         y <- h$counts; y <- y/max(y)
         lines(breaks[-nB], y, col=3, ...) 
         h <- hist(x[cols==4], plot = FALSE)  # post treatment
         breaks <- h$breaks; nB <- length(breaks)
         y <- h$counts; y <- y/max(y)
         lines(breaks[-nB], y, col=4, ...) 
   	 par(usr = c(0,1, 0, 1.5) )
 	 wp=kruskal.test(x,g=pD$type)$p.value
         text(0.0,.93,"Kruskal-Wallis Test", font=3,col=1,cex = .7,pos=4)
  	 txt <- paste("P=",format(c(wp, 0.123456789), digits=4)[1], sep="")
          text(0.0,0.70, txt, col=1,cex = .7,pos=4)
             } 
panel.cor <- function(x, y,...)
     {
         usr <- par("usr"); on.exit(par(usr))
         par(usr = c(0, 1, 0, 1))
         r <- cor.test(x[cols==2], y[cols==2])
         txt <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
         text(0.0, 0.70, txt, col=2,cex = .7,pos=4)
         r <- cor.test(x[cols==3], y[cols==3])
         txt <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
         text(0.0, 0.30, txt, col=3,cex = .7,pos=4)
         r <- cor.test(x[cols==4], y[cols==4])
         txt <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
         text(0.0, 0.50, txt, col=4,cex = .7,pos=4)
     }

cols=1+c(1,3,2)[as.numeric(pD$type)]
pchs=c("b","B","T")[as.numeric(pD$type)]


pairs(DF, pch=pchs,col=cols,cex=.6,diag.panel=panel.hist,lower.panel=panel.cor,gap=0)
title(main="Yeoh et al: b=BCR-ABL B-cell (red); B=TEL-AML1 B-cell (blue);  T=T-cell (green)",line=3,cex.main = .7,   font.main= 3, col.main= "black")

dev.copy(pdf,file="fig4yeoh.pdf", width = 8, height = 8)
dev.off() # close the file device just opened, i.e. the dev.cur()


save(DF,file="yeohExprs.Rdata")


na=data.frame(exprs(sfolate));na
cnt=apply(cbind(apply(na[,1:15],1,median),apply(na[,16:35],1,median),apply(na[,36:49],1,median)),1,mean)#;cnt #this is the baseline for all perturbations
aa=na/(cnt%o%rep(1,dim(na)[1]));aa
aa=cbind(aa,control=rep(1,dim(gpeset)[1]))

rownames(aa)=morrsym

mi=summary(morr)
attach(mi)  # this gives rIDs

M=matrix(rep(1,dim(aa)[2]*length(rIDs)),nrow=length(rIDs))
rownames(M)<-rIDs
colnames(M)<-colnames(aa)
M[names(key),]
tmp=as.matrix(aa[key,])
rownames(tmp)<-names(key)
M[names(key),]=tmp
M

morr$species$EMTX$ic=0
out1=sim(morr,seq(-20,0,1))
morr$species$EMTX$ic=1
out2=sim(morr,0:30)
outs=data.frame(rbind(out1,out2))
morr$species$EMTX$ic=0

attach(outs)

par(mfrow=c(3,4))
plot(time,FH2b,type="l",xlab="Hours")
plot(time,FH2f,type="l",xlab="Hours")
plot(time,DHFRf,type="l",xlab="Hours")
plot(time,DHFRtot,type="l",xlab="Hours")
plot(time,CHOFH4,type="l",xlab="Hours")
plot(time,FH4,type="l",xlab="Hours")
plot(time,CH2FH4,type="l",xlab="Hours")
plot(time,CH3FH4,type="l",xlab="Hours")
plot(time,AICARsyn,type="l",xlab="Hours")
plot(time,MTR,type="l",xlab="Hours")
plot(time,TYMS,type="l",xlab="Hours")
#plot(time,EMTX,type="l",xlab="Hours")
plot(time,DHFReductase,type="l",xlab="Hours")
par(mfrow=c(1,1))
detach(outs)


nFluxes=length(rIDs)
# now make the big flux matrix. This takes time to run!!!!!
flux=matrix(rep(0,nFluxes*50),ncol=nFluxes,nrow=50)
conc=matrix(rep(0,nStates*50),ncol=nStates,nrow=50)
rownames(flux)<-c(paste("b",1:15,sep=""),paste("B",1:20,sep=""),paste("T",1:14,sep=""),"Control")
colnames(flux)<-rIDs
rownames(conc)<-c(paste("b",1:15,sep=""),paste("B",1:20,sep=""),paste("T",1:14,sep=""),"Control")
colnames(conc)<-names(y0)
flux
conc

for (patient in 1:50)
{
print(patient)
out1=sim(morr,seq(-20,0,1),M[,patient])
out2=sim(morr,0:30,M[,patient])
outs=data.frame(rbind(out1,out2))

conc[patient,]=as.numeric(outs[dim(outs)[1],2:(nStates+1)])
flux[patient,]=as.numeric(outs[dim(outs)[1],(nStates+2):(nStates+nFluxes+1)])

par(mfrow=c(3,1))
plot(FH2f~time,data=outs)
title(main=paste("patient ",patient))
plot(FH4~time,data=outs)
plot(CH2FH4~time,data=outs)
par(mfrow=c(1,1))
}

flux=data.frame(flux)
conc=data.frame(conc)
detach(mi)
save(flux,conc,file="FmorrYeohALL.Rdata")# save flux array since it takes much time to recompute
#  END big computation loop

#  Now do plotting and stats for the predicted fluxes
# load("FmorrRossBT.Rdata") # uncomment this if you saved the flux array 4 lines up 
attach(flux)
attach(conc)
#cols=1+as.numeric(pD$type)
#pchs=c("b","T","B")[as.numeric(pD$type)]
#DF=flux[1:49,c("MTHFR","MTHFD","TYMS")]
#DF
#
#pairs(DF, pch=pchs,col=cols,cex=.6,diag.panel=panel.hist,lower.panel=panel.cor,gap=0)
#title(main="Ross et al: b=BCR-ABL B-cell (red); B=TEL-AML1 B-cell (blue);  T=T-cell (green)",line=3,cex.main = .7,   font.main= 3, col.main= "black")
plot(TYMS,MTHFD/2,type="n",xlim=range(TYMS),ylim=range(MTHFD/2),xlab="dTMP Flux (uM/hr)",ylab="DNPS Flux (uM/hr)")
points(TYMS[folate$type=="TEL.AML1"],MTHFD[folate$type=="TEL.AML1"]/2,pch=7)
points(TYMS[folate$type=="T.Cell"],MTHFD[folate$type=="T.Cell"]/2,pch=2)
points(TYMS[folate$type=="BCR.ABL"],MTHFD[folate$type=="BCR.ABL"]/2,pch=1)
legend(locator(n=1),legend=c("BCR-ABL B-cell","TEL-AML1 B-cell","T-cell"), pch=c(1,7,2))
cor.test(TYMS[folate$type=="TEL.AML1"],MTHFD[folate$type=="TEL.AML1"])
cor.test(TYMS[folate$type=="T.Cell"],MTHFD[folate$type=="T.Cell"])
t.test(TYMS[folate$type=="TEL.AML1"],TYMS[folate$type=="T.Cell"])
t.test(MTHFD[folate$type=="TEL.AML1"],MTHFD[folate$type=="T.Cell"])
detach(flux)
detach(conc)

### R code from vignette source 'quick-start.Rnw'

###################################################
### code chunk number 1: read
###################################################
library(SBMLR)
curto=readSBML(system.file("models", "curto.xml", package = "SBMLR"))  
head(summary(curto)$reactions)


###################################################
### code chunk number 2: save
###################################################
saveSBML(curto,"curto.xml")
saveSBMLR(curto,"curto.r")


###################################################
### code chunk number 3: equality
###################################################
curtoX=readSBML("curto.xml")
curtoR=readSBMLR("curto.r")
head((curtoX==curtoR)$species)
head((curtoX==curtoR)$reactions)


###################################################
### code chunk number 4: simulation
###################################################
out1=sim(curto,seq(-20,0,1))
curto$species$PRPP$ic=50
out2=sim(curto,0:70)
outs=data.frame(rbind(out1,out2))
attach(outs) 
par(mfrow=c(2,1))
plot(time,IMP,type="l",xlab="minutes",ylab="IMP (uM)")
plot(time,HX,type="l",xlab="minutes",ylab="HX (uM)")
par(mfrow=c(1,1))
detach(outs)


###################################################
### code chunk number 5: bumpLessXfer
###################################################
curto$species$PRPP$ic=5  # return PRPP IC to its original value
sim(curto,(-10):10,modulator=rep(2,37)) # bumpless transfer in concentrations since all V increase by 2


###################################################
### code chunk number 6: unstable
###################################################
sim(curto,(-10):10,modulator=c(rep(1.1,20),rep(0.9,17))) # half up, half down, not bumpless


###################################################
### code chunk number 7: folateSim
###################################################
morr=readSBML(file.path(system.file(package="SBMLR"), "models/morrison.xml"))  
out1=sim(morr,seq(-20,0,1))
morr$species$EMTX$ic=1 # bolus of methotrexate to 1 uM
out2=sim(morr,0:30)
outs=data.frame(rbind(out1,out2))
attach(outs)
par(mfrow=c(3,4))
plot(time,FH2b,type="l",xlab="Hours")
plot(time,FH2f,type="l",xlab="Hours")
plot(time,DHFRf,type="l",xlab="Hours")
plot(time,DHFRtot,type="l",xlab="Hours")
plot(time,CHOFH4,type="l",xlab="Hours")
plot(time,FH4,type="l",xlab="Hours")
plot(time,CH2FH4,type="l",xlab="Hours")
plot(time,CH3FH4,type="l",xlab="Hours")
plot(time,AICARsyn,type="l",xlab="Hours")
plot(time,MTR,type="l",xlab="Hours")
plot(time,TYMS,type="l",xlab="Hours")
#plot(time,EMTX,type="l",xlab="Hours")
plot(time,DHFReductase,type="l",xlab="Hours")
par(mfrow=c(1,1))
detach(outs)


###################################################
### code chunk number 8: summaryDump
###################################################
summary(curto)
curto

library(SBMLR) 
curto=readSBML(file.path(system.file(package="SBMLR"), "models/curto.xml"))  
(dPRPP10 <- data.frame(var = "PRPP", time = 0, value = 10,method = "mult"))
(out=sim(curto,times=seq(-20,70,1),events = list(data = dPRPP10) ) )
plot(out,which=c("PRPP","den","IMP","HX","Gua","aprt","XMP","Xa","UA"))
# out is a dataframe with class set to deSolve to overload plot, see ?plot.deSolve

model=list( 

id="MorrisonAllegra",

notes=c(
"This is a folate model that includes MTX polyglutamation.", 
"Morrison and Allegra, JBC:264,10552-10566 (1989)",
"Folate cycle kinetics in breast cancer cells.",
"o                                             ",
"Two flow BCs were converted into two downstream",
"concentration BCs, thus removing the GAR and dUMP state variables.",
"This dropped the number of ODEs from 21 to 19.",
"o                                               ",
"The subscript b following some species names implies bound to DHFR.",
"FH2 free and bound to DHFR are in rapid equilibrium.",
"DHFRsyn(thesis) parameters were picked to get SS concentration ",
"right with kdeg=.03 and also to get 1uM MTX to ramp DHFR up by a factor of 3.3.",
"MTX1 efflux is strong enough that GGH21 overwhelms MTX2 export.",
"Keq is a global parameter; this wouldn't be needed if rules had local parameters!",
"DHFR protein degradation reactions are independent of folate binding.",
"In DHFRdeg, since mass cannot come out of the BC it was taken form free DHFR",
"In FH2bdeg we create back the FH2 missing from DHFR protein degradation.",
"The units in this model are concentrations in micromolar and time in hours.",
"Volume sizes of 1 were picked to equate concentrations to mass or moles"
),

compartments=list(
list(id="cell", size = 1),
list(id="ext", size = 1)
),

species=list(
list(id="FH2f"		,ic=  0.0012,	 compartment="cell",	 bc=FALSE),
list(id="FH2b"		,ic=  0.0024,	 compartment="cell",	 bc=TRUE),
list(id="DHFRf"		,ic=    0.64,	 compartment="cell",	 bc=FALSE),
list(id="DHFRtot"	,ic=    0.64,	 compartment="cell",	 bc=TRUE),
list(id="FH4"		,ic=    0.46,	 compartment="cell",	 bc=FALSE),
list(id="CH2FH4"	,ic=    0.26,	 compartment="cell",	 bc=FALSE),
list(id="CH3FH4"	,ic=    1.63,	 compartment="cell",	 bc=FALSE),
list(id="CHOFH4"	,ic=       1,	 compartment="cell",	 bc=FALSE),
list(id="FFH2"		,ic=0.000332,	 compartment="cell",	 bc=FALSE),
list(id="HCHO"		,ic=  0.0074,	 compartment="cell",	 bc=FALSE),
list(id="FGAR"		,ic=   16.49,	 compartment="cell",	 bc=FALSE),
list(id="AICAR"		,ic=   3.695,	 compartment="cell",	 bc=FALSE),
list(id="MTX1"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX2"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX3"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX4"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX5"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX1b"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX2b"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX3b"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX4b"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="MTX5b"		,ic=       0,	 compartment="cell",	 bc=FALSE),
list(id="EMTX"		,ic=       0,	 compartment="ext",	 bc=TRUE),
list(id="dUMP"		,ic=   20.76,	 compartment="cell",	 bc=TRUE),
list(id="GAR"		,ic=   689.6,	 compartment="cell",	 bc=TRUE),
list(id="serine"	,ic=   123.3,	 compartment="cell",	 bc=TRUE),
list(id="formate"	,ic=     500,	 compartment="cell",	 bc=TRUE),
list(id="ATP"		,ic=    2980,	 compartment="cell",	 bc=TRUE),
list(id="glutamine"	,ic=    7170,	 compartment="cell",	 bc=TRUE),
list(id="glycine"	,ic=    1600,	 compartment="cell",	 bc=TRUE),
list(id="NADP"		,ic=    6.73,	 compartment="cell",	 bc=TRUE),
list(id="NADPH"		,ic=     294,	 compartment="cell",	 bc=TRUE),
list(id="homocysteine"	,ic=      10,	 compartment="cell",	 bc=TRUE)
),

globalParameters=list(Keq=0.32), 

rules=list(
list(idOutput=c("FH2b"),
inputs=c("FH2f","DHFRf"),
strLaw="FH2f*DHFRf/Keq"
),

list(idOutput=c("DHFRtot"),
inputs=c("FH2b","DHFRf","MTX1b","MTX2b","MTX3b","MTX4b","MTX5b"),
strLaw="FH2b+DHFRf+MTX1b+MTX2b+MTX3b+MTX4b+MTX5b"
)),
   

reactions=list(
list( id="SHMT", reversible=FALSE,
reactants=c("FH4","serine"),
products=c("CH2FH4"),
parameters=c(Vm = 18330,Km1 = 1.7,Km2 = 210),
strLaw="Vm*(serine/Km2/(1+serine/Km2))*(FH4/Km1/(1+FH4/Km1))"
),

list( id="SHMTr", reversible=FALSE,
reactants=c("CH2FH4"),
modifiers=c("glycine"),
products=c("FH4"),
parameters=c(Vm = 1.22e+007,Km1 = 3200,Km2 = 10000),
strLaw="Vm*(glycine/Km2/(1+glycine/Km2))*(CH2FH4/Km1/(1+CH2FH4/Km1))"
),

list( id="HCHOtoCH2FH4", reversible=FALSE,
reactants=c("FH4","HCHO"),
products=c("CH2FH4"),
parameters=c(hp = 23.2),
strLaw="hp*FH4*HCHO"
),

list( id="CH2FH4toHCHO", reversible=FALSE,
reactants=c("CH2FH4"),
products=c("FH4","HCHO"),
parameters=c(hl = 0.3),
strLaw="hl*CH2FH4"
),

list( id="MTHFR", reversible=FALSE,
reactants=c("CH2FH4","NADPH"),
modifiers=c("FH2f","MTX1","MTX2","MTX3","MTX4","MTX5"),
products=c("CH3FH4"),
parameters=c(Vm = 224.8,Km1 = 50,Km2 = 50,Ki1 = 0.4,Ki21 = 59,Ki22 = 21.3,Ki23 = 7.68,Ki24 = 2.77,Ki25 = 1),
strLaw="Vm*(NADPH/Km2/(1+NADPH/Km2))*(CH2FH4/(CH2FH4+Km1*(1+MTX1/Ki21+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1)))"
),

list( id="MTR", reversible=FALSE,
reactants=c("CH3FH4","homocysteine"),
products=c("FH4"),
parameters=c(Vm = 22600,Km1 = 125,Km2 = 2900),
strLaw="Vm*(homocysteine/Km2/(1+homocysteine/Km2))*(CH3FH4/Km1/(1+CH3FH4/Km1))"
),

list( id="HCOOHtoCHOFH4", reversible=FALSE,
reactants=c("FH4","formate","ATP"),
products=c("CHOFH4"),
parameters=c(Vm = 3600,Km1 = 230,Km2 = 56,Km3 = 1600),
strLaw="Vm*(FH4/Km1/(1+FH4/Km1))*(ATP/Km2/(1+ATP/Km2))*(formate/Km3/(1+formate/Km3))"
),

list( id="GARFT", reversible=FALSE,
reactants=c("CHOFH4","GAR"),
modifiers=c("FH2f","FFH2","MTX1","MTX2","MTX3","MTX4","MTX5"),
products=c("FGAR","FH4"),
parameters=c(Vm = 4126,Km1 = 4.9,Km2 = 52,Ki1 = 5,Ki1f = 1,Ki21 = 84,Ki22 = 60,Ki23 = 43,Ki24 = 31,Ki25 = 22),
strLaw="Vm*(GAR/Km2/(1+GAR/Km2))*(CHOFH4/(CHOFH4+Km1*(1+MTX1/Ki21+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1+FFH2/Ki1f)))"
),

list( id="ATIC7", reversible=FALSE,
reactants=c("CHOFH4","AICAR"),
modifiers=c("FH2f","FFH2","MTX1","MTX2","MTX3","MTX4","MTX5"),
products=c("FH4"),
parameters=c(Vm = 31675,Km1 = 5.5,Km2 = 24,Ki1 = 2.89,Ki1f = 5.3,Ki21 = 40,Ki22 = 31.5,Ki23 = 2.33,Ki24 = 3.61,Ki25 = 5.89),
strLaw="Vm*(AICAR/Km2/(1+AICAR/Km2))*(CHOFH4/(CHOFH4+Km1*(1+MTX1/Ki21+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1+FFH2/Ki1f)))"
),

list( id="MTHFD", reversible=FALSE,
reactants=c("CH2FH4","NADP"),
products=c("CHOFH4"),
parameters=c(Vm = 68500,Km1 = 3,Km2 = 21.8),
strLaw="Vm*(CH2FH4/Km1/(1+CH2FH4/Km1))*(NADP/Km2/(1+NADP/Km2))"
),

list( id="TYMS", reversible=FALSE,
reactants=c("CH2FH4","dUMP"),
modifiers=c("FH2f","FFH2","MTX1","MTX2","MTX3","MTX4","MTX5"),
products=c("FH2f"),
parameters=c(Vm = 58,Km1 = 2.5,Km2 = 1.8,Ki1 = 3,Ki1f = 1.6,Ki21 = 13,Ki22 = 0.08,Ki23 = 0.07,Ki24 = 0.065,Ki25 = 0.047),
strLaw="Vm*(CH2FH4/Km1)*(dUMP/Km2)/((CH2FH4/Km1)*(dUMP/Km2)*(1+MTX1/Ki21+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1)+(dUMP/Km2)*((FFH2/Ki1f)*(MTX1/Ki21)+(1+FFH2/Ki1f)*(1+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1))+(1+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1))"
),

list( id="DHFReductase", reversible=FALSE,
reactants=c("FH2f"),
modifiers=c("FH2b"),
products=c("FH4"),
parameters=c(kter = 2109.4),
strLaw="kter*FH2b"
),

list( id="FFH2syn", reversible=FALSE,
reactants=c("FH2f"),
products=c("FFH2"),
parameters=c(Vm = 65),
strLaw="Vm*FH2f"
),

list( id="ATIC12", reversible=FALSE,
reactants=c("FFH2","AICAR"),
modifiers=c("CHOFH4","FH2f","MTX1","MTX2","MTX3","MTX4","MTX5"),
products=c("FH2f"),
parameters=c(Vm = 9503,Km1 = 5.3,Km2 = 24,Ki1 = 2.89,Ki1f = 5.5,Ki21 = 40,Ki22 = 31.5,Ki23 = 2.33,Ki24 = 3.61,Ki25 = 5.89),
strLaw="Vm*(AICAR/Km2/(1+AICAR/Km2))*(FFH2/(FFH2+Km1*(1+MTX1/Ki21+MTX2/Ki22+MTX3/Ki23+MTX4/Ki24+MTX5/Ki25+FH2f/Ki1+CHOFH4/Ki1f)))"
),

list( id="AICARsyn", reversible=FALSE,
reactants=c("FGAR"),
modifiers=c("glutamine"),
products=c("AICAR"),
parameters=c(Vm = 4656,Km1 = 100,Km2 = 100),
strLaw="Vm*(glutamine/Km1/(1+glutamine/Km1))*(FGAR/Km2/(1+FGAR/Km2))"
),

list( id="FPGS12", reversible=FALSE,
reactants=c("MTX1"),
products=c("MTX2"),
parameters=c(Vm = 0.129),
strLaw="Vm*MTX1"
),

list( id="FPGS23", reversible=FALSE,
reactants=c("MTX2"),
products=c("MTX3"),
parameters=c(Vm = 0.369),
strLaw="Vm*MTX2"
),

list( id="FPGS34", reversible=FALSE,
reactants=c("MTX3"),
products=c("MTX4"),
parameters=c(Vm = 0.118),
strLaw="Vm*MTX3"
),

list( id="FPGS45", reversible=FALSE,
reactants=c("MTX4"),
products=c("MTX5"),
parameters=c(Vm = 0.185),
strLaw="Vm*MTX4"
),

list( id="GGH21", reversible=FALSE,
reactants=c("MTX2"),
products=c("MTX1"),
parameters=c(Vm = 0.195),
strLaw="Vm*MTX2"
),

list( id="GGH32", reversible=FALSE,
reactants=c("MTX3"),
products=c("MTX2"),
parameters=c(Vm = 0.025),
strLaw="Vm*MTX3"
),

list( id="GGH43", reversible=FALSE,
reactants=c("MTX4"),
products=c("MTX3"),
parameters=c(Vm = 0.031),
strLaw="Vm*MTX4"
),

list( id="GGH54", reversible=FALSE,
reactants=c("MTX5"),
products=c("MTX4"),
parameters=c(Vm = 0.191),
strLaw="Vm*MTX5"
),

list( id="RFC", reversible=FALSE,
reactants=c("EMTX"),
products=c("MTX1"),
parameters=c(Vm = 82.2,Km = 8.2),
strLaw="Vm*EMTX/Km/(1+EMTX/Km)"
),

list( id="MTX1export", reversible=FALSE,
reactants=c("MTX1"),
parameters=c(Vm = 4.65),
strLaw="Vm*MTX1"
),

list( id="MTX2export", reversible=FALSE,
reactants=c("MTX2"),
parameters=c(Vm = 0),
strLaw="Vm*MTX2"
),

list( id="MTX3export", reversible=FALSE,
reactants=c("MTX3"),
parameters=c(Vm = 0.063),
strLaw="Vm*MTX3"
),

list( id="MTX4export", reversible=FALSE,
reactants=c("MTX4"),
parameters=c(Vm = 0.063),
strLaw="Vm*MTX4"
),

list( id="MTX5export", reversible=FALSE,
reactants=c("MTX5"),
parameters=c(Vm = 0.063),
strLaw="Vm*MTX5"
),

list( id="MTX1on", reversible=FALSE,
reactants=c("MTX1","DHFRf"),
products=c("MTX1b"),
parameters=c(Vm = 23100),
strLaw="Vm*DHFRf*MTX1"
),

list( id="MTX2on", reversible=FALSE,
reactants=c("MTX2","DHFRf"),
products=c("MTX2b"),
parameters=c(Vm = 44300),
strLaw="Vm*DHFRf*MTX2"
),

list( id="MTX3on", reversible=FALSE,
reactants=c("MTX3","DHFRf"),
products=c("MTX3b"),
parameters=c(Vm = 85100),
strLaw="Vm*DHFRf*MTX3"
),

list( id="MTX4on", reversible=FALSE,
reactants=c("MTX4","DHFRf"),
products=c("MTX4b"),
parameters=c(Vm = 163000),
strLaw="Vm*DHFRf*MTX4"
),

list( id="MTX5on", reversible=FALSE,
reactants=c("MTX5","DHFRf"),
products=c("MTX5b"),
parameters=c(Vm = 314000),
strLaw="Vm*DHFRf*MTX5"
),

list( id="MTX1off", reversible=FALSE,
reactants=c("MTX1b"),
products=c("MTX1","DHFRf"),
parameters=c(Vm = 0.42),
strLaw="Vm*MTX1b"
),

list( id="MTX2off", reversible=FALSE,
reactants=c("MTX2b"),
products=c("MTX2","DHFRf"),
parameters=c(Vm = 0.42),
strLaw="Vm*MTX2b"
),

list( id="MTX3off", reversible=FALSE,
reactants=c("MTX3b"),
products=c("MTX3","DHFRf"),
parameters=c(Vm = 0.42),
strLaw="Vm*MTX3b"
),

list( id="MTX4off", reversible=FALSE,
reactants=c("MTX4b"),
products=c("MTX4","DHFRf"),
parameters=c(Vm = 0.42),
strLaw="Vm*MTX4b"
),

list( id="MTX5off", reversible=FALSE,
reactants=c("MTX5b"),
products=c("MTX5","DHFRf"),
parameters=c(Vm = 0.42),
strLaw="Vm*MTX5b"
),

list( id="DHFRfsyn", reversible=FALSE,
modifiers=c("EMTX"),
products=c("DHFRf"),
parameters=c(k0 = 0.0192,k1 = 0.04416),
strLaw="k0+k1*EMTX"
),

list( id="DHFRdeg", reversible=FALSE,
reactants=c("DHFRf"),
modifiers=c("FH2b"),
parameters=c(Vm = 0.03),
strLaw="Vm*(DHFRf+FH2b)"
),

list( id="FH2bdeg", reversible=FALSE,
modifiers=c("FH2b"),
products=c("FH2f"),
parameters=c(Vm = 0.03),
strLaw="Vm*FH2b"
),

list( id="MTX1deg", reversible=FALSE,
reactants=c("MTX1b"),
products=c("MTX1"),
parameters=c(Vm = 0.03),
strLaw="Vm*MTX1b"
),

list( id="MTX2deg", reversible=FALSE,
reactants=c("MTX2b"),
products=c("MTX2"),
parameters=c(Vm = 0.03),
strLaw="Vm*MTX2b"
),

list( id="MTX3deg", reversible=FALSE,
reactants=c("MTX3b"),
products=c("MTX3"),
parameters=c(Vm = 0.03),
strLaw="Vm*MTX3b"
),

list( id="MTX4deg", reversible=FALSE,
reactants=c("MTX4b"),
products=c("MTX4"),
parameters=c(Vm = 0.03),
strLaw="Vm*MTX4b"
),

list( id="MTX5deg", reversible=FALSE,
reactants=c("MTX5b"),
products=c("MTX5"),
parameters=c(Vm = 0.03),
strLaw="Vm*MTX5b"
)) 

)  # end model

library(SBMLR)
setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
morr=readSBMLR(file.path(system.file(package="SBMLR"), "models/morrison.r"))  
out1=sim(morr,seq(-20,0,1))
morr$species$EMTX$ic=1
out2=sim(morr,0:30)
outs=data.frame(rbind(out1,out2))
attach(outs)
par(mfrow=c(3,3))
plot(time,EMTX,type="l",xlab="Hours",ylab="EMTX")
plot(time,FH2b+FH2f,type="l",xlab="Hours",ylab="DHF")
plot(time,CH2FH4,type="l",xlab="Hours",ylab="CH2THF")
plot(time,CHOFH4,type="l",xlab="Hours",ylab="CHOTHF")
plot(time,FH4,type="l",xlab="Hours",ylab="THF")
plot(time,CH3FH4,type="l",xlab="Hours",ylab="CH3THF")
plot(time,MTHFR,type="l",xlab="Hours",ylab="MTHFR")
plot(time,GARFT,type="l",xlab="Hours",ylab="GARFT")
plot(time,TYMS,type="l",xlab="Hours",ylab="TYMS")
par(mfrow=c(1,1))
detach(outs)
morr$species$EMTX$ic=0
dev.copy(pdf,file="fig2.pdf", width = 7, height = 7)
dev.off()

# This is the SOD model of Kowald et al, JTB 238 (2006) 828–840. 
ic=c(
		SO		=  0,    #    4e-11,
		SODII	=  5e-6,
		H2O2	=  0,    #  1e-9,
		OH		=  0,    #  1e-23,
		L     =  0,    #  1e-11,
		LOO   =  0,    #  7e-8,   # = ~ final values in Fig. 2
		LOOH	=  0     #  1.5e-6
)

parameters=c( 
		k1  =6.6e-7,
		k2  =1.6e9,
		k3  =1.6e9,
		k4  =1e5,
		k5  =2e4,
		k6  =1,
		k7  =3.4e7,
		k9  =1e6,
		k10 =1e3,
		k11 =2.5e8,
		k12 =0.38,
		k13a=8.7e-3,
		k13b=8.7e-3,
		k17 =3e4,
		k18 =7,
		k19 =8.8e4,
    Keq= 100,
		SOD  =   1e-5,
		catalase =1e-5
)




sod<-function(t, state, parameters) {
# reality check. 1e-23M => 6 OH/Liter => 6 OH per 10^12 cells, i.e. <<< 1 per cell
#     state[state<0]=1e-23
#     state[state<0]=0   # this caused some instability, so remove from SBMLR
#    if (state["SODII"]>SOD) state["SODII"]=SOD 
	with(as.list(c(state, parameters)),{
        HSO=SO/Keq     #explicit HSO so we can monitor it
 				SODI=SOD-SODII # this can also be done with an additional ode
				etcV1=k1
				sooV2=k2*SO*SODII
				sorV3=k3*SO*SODI
				loorV4=k4*SO*LOO
				habWeiV5=k5*SO*H2O2
				sodFenV6=k6*H2O2*SODII
				catGpxV7=k7*H2O2*catalase
				ohSinkV9=k9*OH
				hsoLipPeroxV10=k10*HSO # this is also the flux through the fast reaction
				hoLipPeroxV11=k11*OH
				loohDeOxV12=k12*LOOH
				sodoV13a=k13a*SODI
				sodrV13b=k13b*SODII
				lipRadOxV17=k17*L
				chainRxV18=k18*LOO
				looSelfV19=k19*LOO^2
				dSO	 = etcV1 - sooV2 - sorV3 -loorV4 - habWeiV5 -hsoLipPeroxV10
				dH2O2  =	sorV3 + hsoLipPeroxV10 - habWeiV5 -sodFenV6	-catGpxV7			
				dOH	 =	habWeiV5 + 2*sodFenV6	- ohSinkV9 - hoLipPeroxV11 # I think this 2 should be 1	
				dL		 = hsoLipPeroxV10	+ hoLipPeroxV11 + chainRxV18 - lipRadOxV17			
 				dLOO   =	lipRadOxV17	- chainRxV18 -loorV4 - 2*looSelfV19		
				dLOOH	 = chainRxV18 - loohDeOxV12 + loorV4
				dSODII = sorV3 + sodoV13a - sooV2 - sodrV13b
				list(c(dSO, dSODII, dH2O2, dOH, dL, dLOO, dLOOH),
						c(HSO=HSO,SODI=SODI,etcV1=etcV1, sooV2=sooV2, sorV3=sorV3, loorV4=loorV4, 
								habWeiV5=habWeiV5, sodFenV6=sodFenV6, catGpxV7=catGpxV7, 
						  ohSinkV9=ohSinkV9, hsoLipPeroxV10=hsoLipPeroxV10, hoLipPeroxV11=hoLipPeroxV11, 
								loohDeOxV12=loohDeOxV12, sodoV13a=sodoV13a, sodrV13b=sodrV13b, 
								lipRadOxV17=lipRadOxV17, chainRxV18=chainRxV18, looSelfV19=looSelfV19)
				)
			}) # end with.
}


library(deSolve)
out=ode(y = ic, times = seq(0,1000,1), func = sod, parms = parameters) 
head(out)
plot(out)

library(SBMLR)
setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
#setwd("C:/cwru/active/Morrison")  # set this to where figs should be dumped, with comment removed
library(rossEset)
pD=subset(pData(ross),subset=(type=="TEL.AML1")|(type=="T.Cell")|(type=="BCR.ABL"))
pD$type=factor(pD$type, levels=c("BCR.ABL","TEL.AML1","T.Cell"))
pD$type
as.numeric(pD$type)
I=order(pD$type)
pD=pD[I,]

cols=1+c(1,3,2)[as.numeric(pD$type)]
pchs=c("b","B","T")[as.numeric(pD$type)]


par(mfrow=c(2,2))

load("rossExprs.Rdata") 
attach(DF)


plot(TYMS,MTHFD1, pch=pchs,col=cols,cex=.6,ylim=c(0,3000),xlim=c(0,30000))
title(main="Ross et al. ",line=1,cex.main = 1,   font.main= 3, col.main= "black")
x=DF
r <- cor.test(x[cols==2,"TYMS"], x[cols==2,"MTHFD1"])
txt1 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 3000, txt1, col=2,cex = .7,pos=4)
r <- cor.test(x[cols==3,"TYMS"], x[cols==3,"MTHFD1"])
txt2 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 2700, txt2, col=3,cex = .7,pos=4)
r <- cor.test(x[cols==4,"TYMS"], x[cols==4,"MTHFD1"])
txt3 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 2850, txt3, col=4,cex = .7,pos=4)
detach(DF)

load("yeohExprs.Rdata") 
attach(DF)
plot(TYMS,MTHFD1, pch=pchs,col=cols,cex=.6,ylim=c(0,2500),xlim=c(0,12000))
title(main="Yeoh et al. ",line=1,cex.main = 1,   font.main= 3, col.main= "black")
x=DF
r <- cor.test(x[cols==2,"TYMS"], x[cols==2,"MTHFD1"])
txt1 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 2500, txt1, col=2,cex = .7,pos=4)
r <- cor.test(x[cols==3,"TYMS"], x[cols==3,"MTHFD1"])
txt2 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 2200, txt2, col=3,cex = .7,pos=4)
r <- cor.test(x[cols==4,"TYMS"], x[cols==4,"MTHFD1"])
txt3 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 2350, txt3, col=4,cex = .7,pos=4)
detach(DF)

load("FmorrRossAll.Rdata") 
DF=flux[1:49,c("MTHFD","TYMS")]
attach(DF)
plot(TYMS,MTHFD/2, pch=pchs,col=cols,cex=.6,xlab="dTMP Flux (uM/hr)",ylab="DNPS Flux (uM/hr)",ylim=c(0,1300),xlim=c(0,14))
title(main="Ross et al. ",line=1,cex.main = 1,   font.main= 3, col.main= "black")
x=DF
r <- cor.test(x[cols==2,1], x[cols==2,2])
txt1 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1300, txt1, col=2,cex = .7,pos=4)
r <- cor.test(x[cols==3,1], x[cols==3,2])
txt2 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1150, txt2, col=3,cex = .7,pos=4)
r <- cor.test(x[cols==4,1], x[cols==4,2])
txt3 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1225, txt3, col=4,cex = .7,pos=4)
detach(DF)


load("FmorrYeohALL.Rdata") 
DF=flux[1:49,c("MTHFD","TYMS")]
attach(DF)
plot(TYMS,MTHFD/2, pch=pchs,col=cols,cex=.6,xlab="dTMP Flux (uM/hr)",ylab="DNPS Flux (uM/hr)",ylim=c(0,1300),xlim=c(0,14))
title(main="Yeoh et al. ",line=1,cex.main = 1,   font.main= 3, col.main= "black")
x=DF
r <- cor.test(x[cols==2,1], x[cols==2,2])
txt1 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1300, txt1, col=2,cex = .7,pos=4)
r <- cor.test(x[cols==3,1], x[cols==3,2])
txt2 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1150, txt2, col=3,cex = .7,pos=4)
r <- cor.test(x[cols==4,1], x[cols==4,2])
txt3 <- paste("r=",format(c(r$estimate, 0.123456789), digits=2)[1]," P=",format(c(r$p.value, 0.123456789), digits=2)[1], sep="")
text(0, 1225, txt3, col=4,cex = .7,pos=4)
detach(DF)


par(mfrow=c(1,1))
dev.copy(pdf,file="fig5abcd.pdf", width = 7, height = 7)

dev.off()

#sod.R
model=list( 
  
  id="sod",
  
  notes=c(
    "This is the SOD model of Kowald et al, JTB 238 (2006) 828-840.", 
    "Below, L is lipid radical, SO is superoxide, OH=hydroxyl radical,",
    "LOO is a radical, and LOOH is stable oxidized lipid.",
    "SOD is the total SOD, SODII=metal oxidized, SODII=reduced.",
    "HSO is protonated SO, a fast reaction; HSO neutral so it crosses membranes.",
    "Catalase. T and SODT are externally manipulated boundary conditions (bc).",
    "HSO and SODI are rule/algebraically determined. They are cloaked here as bc.",
    "Units are all in molar (M) and in seconds."
  ),
  
  
  compartments=list(
    list(id="cell", size = 1)
  ),
  
  
  species=list(
    list(id="SO"		,ic=       0,    compartment="cell",bc=  FALSE),
    list(id="SODII"	,ic=   5e-06,    compartment="cell",bc=  FALSE),
    list(id="H2O2"	,ic=       0,    compartment="cell",bc=  FALSE),
    list(id="OH"		,ic=       0,    compartment="cell",bc=  FALSE),
    list(id="L"		  ,ic=       0,    compartment="cell",bc=  FALSE),
    list(id="LOO"   ,ic=       0,    compartment="cell",bc=  FALSE),
    list(id="LOOH"	,ic=       0,    compartment="cell",bc=  FALSE),
#     list(id="HSO"		,ic=  0.0024,	   compartment="cell",bc=	 TRUE), # from BioModel
#     list(id="SODI"	,ic=    0.64,	   compartment="cell",bc=	 TRUE), #
    list(id="HSO"  	,ic=       0,	   compartment="cell",bc=	 TRUE), # from paper
    list(id="SODI"	,ic=    5e-6,	   compartment="cell",bc=	 TRUE), #
    list(id="SOD" 	,ic=   1e-05,    compartment="cell",bc=  TRUE),
    list(id="catalase"		,ic=   1e-05,    compartment="cell",bc=  TRUE)
  ),
  
   globalParameters=list(Keq=100), 
  
  
  #BEGIN the Rules Section
  rules=list(
    list(idOutput="HSO",
         inputs=c("SO"),
          strLaw = "SO/Keq"
#          strLaw = "SO/100"
    ),
    
    list(idOutput="SODI",
         inputs=c("SOD","SODII"),
         strLaw = "SOD-SODII"
    )),
  # END of the Rules Section
  
  
  #BEGIN the Reaction Section 
  reactions=list(
    list( id="etcV1",  
          parameters=c(k1=6.6e-7),
          products=c("SO"),
          strLaw="k1*1" # avoid a bug in my code by giving this an operator
    ),
    
    list( id="sooV2",  
          reactants=c("SO","SODII"),
          parameters=c(k2=1.6e9),
          strLaw="k2*SO*SODII"
    ),
    
    list( id="sorV3",  
          reactants=c("SO"),
          modifiers=c("SODI"),
          products=c("H2O2","SODII"),
          parameters=c(k3=1.6e9),
          strLaw="k3*SO*SODI"
    ),
    
    list( id="loorV4",  
          reactants=c("SO","LOO"),
          products=c("LOOH"),
          parameters=c(k4=1e5),
          strLaw="k4*SO*LOO"
    ),
    
    list( id="habWeiV5",  
          reactants=c("SO","H2O2"),
          products=c("OH"), # SO becomes O2, makes -OH anion also,  
          parameters=c(k5=2e4),   # neither of which are book keeped
          strLaw="k5*SO*H2O2"
    ),
    
    list( id="sodFenV6",  
          reactants=c("H2O2"),
          modifiers=c("SODII"),
          products=c("OH","OH"),
          parameters=c(k6=1),
          strLaw="k6*H2O2*SODII"
    ),
    
    list( id="catGpxV7",  
          reactants=c("H2O2"),
          modifiers=c("catalase"),
          parameters=c(k7=3.4e7),
          strLaw="k7*H2O2*catalase"
    ),
    
    list( id="ohSinkV9",  
          reactants=c("OH"),
          parameters=c(k9=1e6),
          strLaw="k9*OH"
    ),
    
    list( id="hsoLipPeroxV10",  
          products=c("L","H2O2"),
          modifiers=c("HSO"),
          parameters=c(k10=1000),
          strLaw="k10*HSO"
    ),

    
    list( id="hoLipPeroxV11",  
          reactants=c("OH"),
          products=c("L"),
          parameters=c(k11=2.5e+08),
          strLaw="k11*OH"
    ),
    
    list( id="loohDeOxV12",  
          reactants=c("LOOH"),
          parameters=c(k12=0.38),
          strLaw="k12*LOOH"
    ),
    
    list( id="sodoV13a",  
          products=c("SODII"),
          modifiers=c("SODI"),
          parameters=c(k13a=0.0087),
          strLaw="k13a*SODI"
    ),
    
    list( id="sodrV13b",  
          reactants=c("SODII"),
          parameters=c(k13b=0.0087),
          strLaw="k13b*SODII"
    ),

#     list( id="hsoSynFastV16",  # v16 also not shown in Fig. 1 
#           reactants=c("SO"),
#           parameters=c(k10=1000),
#           strLaw="k10*SO"
#     ),
    
  
    
    list( id="lipRadOxV17",  
          reactants=c("L"),
          products=c("LOO"),
          parameters=c(k17=30000),
          strLaw="k17*L"
    ),
    
    list( id="chainRxV18",  
          reactants=c("LOO"),
          products=c("L","LOOH"),
          parameters=c(k18=7),
          strLaw="k18*LOO"
    ),
    
  
    
    list( id="looSelfV19",  
          reactants=c("LOO","LOO"),
          parameters=c(k19=88000),
          strLaw="k19*LOO^2"
    )
    
    
  ) #END of the Reaction Section
  
  
)  # END of the Model!

# Comment: relative to Curto an Morrison, wherein the *.R file was the editable 
# source code, I'm now switching to the use of JDesigner as my source editor
# (model IDE). Thus, for Kowald's SOD models I  now provide only the JDesigner
# xml file as the model source code. This is my new workflow. 
library(SBMLR)
sod=readSBML(file.path(system.file(package="SBMLR"), "models/SOD2006JD.xml"))  
summary(sod)
out=sim(sod,times=seq(0,1000,1) ) 
plot(out)  #reproduces Fig 2 of JTB 2006    
# Note: In RStudio, switch to console and hit return repeatedly to plot

(ssic=out[dim(out)[1],2:9]) # set ic to steady state
(SOadd <- data.frame(var = "SO", time = 0, value = 1e9,method = "mult"))
out=sim(sod,X0=ssic,times=seq(-10,10,.1),events = list(data = SOadd) ) 
plot(out) # note the SO looks like it dropped, but then why the LOOH go up
# Answer, sampling times are too big at 1 sec, need to get to sub millisecs
out=sim(sod,X0=ssic,times=seq(-.001,.001,.00001),events = list(data = SOadd) ) 
plot(out) # now you can actually see the upward spike of SuperOxide, SO

# This is Morrison's folate model driven by random data
library(Biobase)
library(annotate)
library(hgu95av2)
library(SBMLR)  

setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
morr=readSBMLR(file.path(system.file(package="SBMLR"), "models/morrison.r"))  

morrsym=c('MTHFD1','GART','ATIC','TYMS','DHFR')
morrsym=c('SHMT1','MTHFR','MTR','MTHFD1','GART','ATIC','TYMS','DHFR')
key=c(GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")
key=c(MTHFR="MTHFR",MTR="MTR",SHMT="SHMT1",SHMTr="SHMT1",GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")

#npats=1000 # this is the real one in the paper, but it takes ~10 hours! ... I will look for faster ways shortly, perhaps via pysces. 
npats=10
aa=matrix(rnorm(npats*length(morrsym),mean=1,sd=.3),ncol=npats)
aa=cbind(aa,control=rep(1,length(morrsym)) )
rownames(aa)=morrsym
colnames(aa)<-c(paste("r",1:npats,sep=""),"control")

mi=summary(morr)
attach(mi)  # this gives rIDs

M=matrix(rep(1,dim(aa)[2]*length(rIDs)),nrow=length(rIDs))
rownames(M)<-rIDs
colnames(M)<-colnames(aa)
M[names(key),]
tmp=as.matrix(aa[key,])
rownames(tmp)<-names(key)
M[names(key),]=tmp
M


nFluxes=length(rIDs)
# now make the big flux matrix. This takes time to run!!!!!
flux=matrix(rep(0,nFluxes*(npats+1)),ncol=nFluxes,nrow=(npats+1))
conc=matrix(rep(0,nStates*(npats+1)),ncol=nStates,nrow=(npats+1))
rownames(flux)<-c(paste("r",1:npats,sep=""),"control")
colnames(flux)<-rIDs
rownames(conc)<-c(paste("r",1:npats,sep=""),"control")
colnames(conc)<-names(y0)
flux
conc

for (patient in 1:(npats+1))
{
print(patient)
out1=sim(morr,seq(-20,0,1),M[,patient])
out2=sim(morr,0:30,M[,patient])
outs=data.frame(rbind(out1,out2))

conc[patient,]=as.numeric(outs[dim(outs)[1],2:(nStates+1)])
flux[patient,]=as.numeric(outs[dim(outs)[1],(nStates+2):(nStates+nFluxes+1)])

par(mfrow=c(3,1))
plot(FH2f~time,data=outs)
title(main=paste("patient ",patient))
plot(FH4~time,data=outs)
plot(CH2FH4~time,data=outs)
par(mfrow=c(1,1))
}

flux=data.frame(flux)
conc=data.frame(conc)
detach(mi)
save(flux,conc,file="FmorrRand.Rdata")# save flux array since it takes much time to recompute
#  END big computation loop

#  Now do plotting and stats for the predicted fluxes
# load("FmorrRossBT.Rdata") # uncomment this if you saved the flux array 4 lines up 
attach(flux)
attach(conc)
plot(TYMS,MTHFD/2,pch=1,xlim=range(TYMS),ylim=range(MTHFD/2),xlab="dTMP Flux (uM/hr)",ylab="DNPS Flux (uM/hr)")
detach(flux)
detach(conc)

# This is Morrison's folate model driven by Vivian Cheung et al's Radiation time course response data (GDS479).
library(Biobase)
library(annotate)
library(hgu95av2)
library(SBMLR)  
setwd(file.path(system.file(package="SBMLR"), "BMCcancerFolates")) #default dump site 
morr=readSBMLR(file.path(system.file(package="SBMLR"), "models/morrison.r"))  
library(cheungEset)
eset=cheung
pD=pData(eset);pD
morrsym=c('SHMT1','MTHFR','MTR','MTHFD1','GART','ATIC','TYMS','DHFR')
#morrsym=c('MTR','MTHFD1','GART','ATIC','TYMS','DHFR')
#key=c(MTHFR="MTHFR",MTR="MTR",SHMT="SHMT1",SHMTr="SHMT1",GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")
key=c(MTR="MTR",GARFT="GART",ATIC7="ATIC",MTHFD="MTHFD1",TYMS="TYMS",DHFReductase="DHFR",ATIC12="ATIC")

AffyID<- ls(env = hgu95av2SYMBOL)
lsym <- mget(AffyID, env = hgu95av2SYMBOL)
sym <- as.character(lsym)
names(sym)=names(lsym)
mID=names(sort(sym[is.element(sym,morrsym)]))
folate <- eset[mID, ]
msym=as.character(mget(mID, env = hgu95av2SYMBOL))
om <- esApply(folate[mID,], 1, mean) 
outdat=data.frame(ID=mID,sym=msym,om)#[om>500,] 
outdat  # dump out the table


counts=summary(outdat$sym)
noutdat=data.frame(NULL)
k=1
for (j in 1:length(counts)) 
   {
   kw=outdat$om[k:(k+counts[j]-1)]
   noutdat=rbind(noutdat,outdat[k+which(kw==max(kw))-1, ]    )
#   kw=outdat$pvals[k:(k+counts[j]-1)]
#   noutdat=rbind(noutdat,outdat[k+which(kw==min(kw))-1, ]    )
k=k+counts[j]
   }
k
noutdat

row.names(noutdat)<-noutdat$sym
noutdat=noutdat[morrsym,]


noutdat
write.table(noutdat,"table1Cheung.csv",sep=",",row.names=F)
sID=as.character(noutdat$ID)
sfolate <- folate[sID, ]  # no doubles in sfolate 
na=data.frame(exprs(sfolate));na
#na[na<200]=200 # set a floor to avoid negative values
cnt=apply(na[,pD$dose==0],1,mean)#;cnt #this is the baseline for all perturbations
aa=na/(cnt%o%rep(1,dim(na)[2]));aa
aa=cbind(aa,ctrl=rep(1,dim(na)[1]))
rownames(aa)=morrsym

mi=summary(morr)
attach(mi)  # this gives rIDs

M=matrix(rep(1,dim(aa)[2]*length(rIDs)),nrow=length(rIDs))
rownames(M)<-rIDs
colnames(M)<-colnames(aa)
M[names(key),]
tmp=as.matrix(aa[key,])
rownames(tmp)<-names(key)
M[names(key),]=tmp
M

M3= cbind(M[,"ctrl"],M[,pD$dose==3] )
M10=cbind(M[,"ctrl"],M[,pD$dose==10])
times=c(0,1,2,6,12,24)
finet=seq(0,24,.1)

# make up a dummy list of the right length
mods3=list(NULL)
mods10=list(NULL)
for (i in 1:length(rIDs))
{
mods3[[i]]=1
mods10[[i]]=1
}
names(mods3)<-rIDs
names(mods10)<-rIDs

for (i in 1:length(rIDs))
{
mods3[[i]]=approxfun(times,M3[rIDs[i],],method="linear",rule=2)
mods10[[i]]=approxfun(times,M10[rIDs[i],],method="linear",rule=2)
}

Mt=mods3
out1=sim(morr,seq(-10,0,1),Mt)
out2=sim(morr,0:30,Mt)
gray3=data.frame(rbind(out1,out2))
Mt=mods10  
out1=sim(morr,seq(-10,0,1),Mt)
out2=sim(morr,0:30,Mt)
gray10=data.frame(rbind(out1,out2))

graphics.off()  # clear off current figures
toPlot=c("TYMS","GARFT")
par(mfrow=c(1,2),mex=.7)
for (i in 1:length(toPlot))
{
plot(gray3[,"time"],gray3[,toPlot[i]],type="l",lty=1,ylab=toPlot[i],xlab="Hours",ylim=range(c(gray3[,toPlot[i]],gray10[,toPlot[i]])) ) #,xlim=c(0,24))
lines(gray10[,"time"],gray10[,toPlot[i]],lty=2)
if (i==2) legend(12,650,legend=c("3 gray","10 gray"),lty=c(1,2))
}

dev.copy(pdf,file="fig8cheungOut.pdf", width = 7.5, height = 7.5)
dev.off() # close the file device just opened, i.e. the dev.cur()

windows(xpos=-220,ypos=-50)  # place interpolation plots in a separate figure window down and to the left
toPlot=c("MTHFR","MTR","SHMT","MTHFD","GARFT","ATIC7","TYMS","DHFReductase")

par(mfrow=c(3,3),mex=.7)
for (i in 1:length(toPlot))
{
plot(times,M3[toPlot[i],],type="p",pch=2,ylab=toPlot[i],xlim=c(0,24),ylim=c(0,2))
lines(finet,mods3[[toPlot[i]]](finet))
points(times,M10[toPlot[i],],type="p",pch=3)
lines(finet,mods10[[toPlot[i]]](finet),lty=2)
if (i==1) legend(5,2,legend=c("3 gray","10 gray"),pch=c(2,3))
}
par(mfrow=c(1,1))
detach(mi)  

# use the other cheung script to get figure 7 with all of the genes!

#dev.copy(pdf,file="curCheungIn.pdf", width = 7.5, height = 7.5)  
#dev.off() # close the file device just opened, i.e. the dev.cur()

model=list( 

id="curto",

notes=c(
"This is a purine metabolism model that is geared toward studies of gout.", 
"The model is fully described in Curto et al., MBSC 151 (1998) pp 1-49",
"The model uses Generalized Mass Action (GMA;i.e. power law) descriptions of reaction rate laws.",
"Such descriptions are local approximations that assume independent substrate binding. ",
"                    ",
"The de novo purine flux vden= 2.39 is in umole/min/KG, i.e. 2.4*60=144 uM/h if we let each Kg be a",
"liter of water. Morrison and Allegra (JBC, 1989) have vden at 650 uM/h (model) and 415 (exp).",
"The IC's below have been set to the system's steady state.",
"The units in this model are micromolar(uM) and minutes.",
"A cell volume of 1 is used so that amounts and concentrations are the same thing."
),

compartments=list(
list(id="cell", size = 1)
),

species=list(
list(id="PRPP"		,ic= 5.01742,	 compartment="cell",	 bc=FALSE),
list(id="IMP"		,ic= 98.2634,	 compartment="cell",	 bc=FALSE),
list(id="SAMP"		,ic=0.198189,	 compartment="cell",	 bc=FALSE),
list(id="ATP"		,ic= 2475.35,	 compartment="cell",	 bc=FALSE),
list(id="SAM"		,ic= 3.99187,	 compartment="cell",	 bc=FALSE),
list(id="Ade"		,ic= 0.98473,	 compartment="cell",	 bc=FALSE),
list(id="XMP"		,ic=  24.793,	 compartment="cell",	 bc=FALSE),
list(id="GTP"		,ic= 410.223,	 compartment="cell",	 bc=FALSE),
list(id="dATP"		,ic= 6.01413,	 compartment="cell",	 bc=FALSE),
list(id="dGTP"		,ic= 3.02581,	 compartment="cell",	 bc=FALSE),
list(id="RNA"		,ic= 28680.5,	 compartment="cell",	 bc=FALSE),
list(id="DNA"		,ic= 5179.34,	 compartment="cell",	 bc=FALSE),
list(id="HX"		,ic= 9.51785,	 compartment="cell",	 bc=FALSE),
list(id="Xa"		,ic= 5.05941,	 compartment="cell",	 bc=FALSE),
list(id="Gua"		,ic= 5.50638,	 compartment="cell",	 bc=FALSE),
list(id="UA"		,ic= 100.293,	 compartment="cell",	 bc=FALSE),
list(id="R5P"		,ic=      18,	 compartment="cell",	 bc=TRUE),
list(id="Pi"		,ic=    1400,	 compartment="cell",	 bc=TRUE)
),

reactions=list(
list( id="ada", reversible=FALSE,
reactants=c("ATP"),
products=c("HX"),
parameters=c(aada = 0.001062,fada4 = 0.97),
strLaw="aada*ATP^fada4"
),

list( id="ade", reversible=FALSE,
reactants=c("Ade"),
parameters=c(aade = 0.01,fade6 = 0.55),
strLaw="aade*Ade^fade6"
),

list( id="adna", reversible=FALSE,
reactants=c("dATP"),
modifiers=c("dGTP"),
products=c("DNA"),
parameters=c(aadna = 3.2789,fdnap9 = 0.42,fdnap10 = 0.33),
strLaw="aadna*dATP^fdnap9*dGTP^fdnap10"
),

list( id="adrnr", reversible=FALSE,
reactants=c("ATP"),
modifiers=c("dGTP","dATP"),
products=c("dATP"),
parameters=c(aadrnr = 0.0602,fadrnr4 = 0.1,fadrnr9 = -0.3,fadrnr10 = 0.87),
strLaw="aadrnr*ATP^fadrnr4*dATP^fadrnr9*dGTP^fadrnr10"
),

list( id="ampd", reversible=FALSE,
reactants=c("ATP"),
modifiers=c("GTP","Pi"),
products=c("IMP"),
parameters=c(aampd = 0.02688,fampd4 = 0.8,fampd8 = -0.03,fampd18 = -0.1),
strLaw="aampd*ATP^fampd4*GTP^fampd8*Pi^fampd18"
),

list( id="aprt", reversible=FALSE,
reactants=c("PRPP","Ade"),
modifiers=c("ATP"),
products=c("ATP"),
parameters=c(aaprt = 233.8,faprt1 = 0.5,faprt4 = -0.8,faprt6 = 0.75),
strLaw="aaprt*PRPP^faprt1*ATP^faprt4*Ade^faprt6"
),

list( id="arna", reversible=FALSE,
reactants=c("ATP"),
modifiers=c("GTP"),
products=c("RNA"),
parameters=c(aarna = 614.5,frnap4 = 0.05,frnap8 = 0.13),
strLaw="aarna*ATP^frnap4*GTP^frnap8"
),

list( id="asuc", reversible=FALSE,
reactants=c("IMP"),
modifiers=c("ATP","GTP","Pi"),
products=c("SAMP"),
parameters=c(aasuc = 3.5932,fasuc2 = 0.4,fasuc4 = -0.24,fasuc8 = 0.2,fasuc18 = -0.05),
strLaw="aasuc*IMP^fasuc2*ATP^fasuc4*GTP^fasuc8*Pi^fasuc18"
),

list( id="asli", reversible=FALSE,
reactants=c("SAMP"),
modifiers=c("ATP"),
products=c("ATP"),
parameters=c(aasli = 66544,fasli3 = 0.99,fasli4 = -0.95),
strLaw="aasli*SAMP^fasli3*ATP^fasli4"
),

list( id="dada", reversible=FALSE,
reactants=c("dATP"),
products=c("HX"),
parameters=c(adada = 0.03333,fdada9 = 1),
strLaw="adada*dATP^fdada9"
),

list( id="den", reversible=FALSE,
reactants=c("PRPP"),
modifiers=c("dGTP","IMP","ATP","GTP","Pi"),
products=c("IMP"),
parameters=c(aden = 5.2728,fden1 = 2,fden2 = -0.06,fden4 = -0.25,fden8 = -0.2,fden18 = -0.08),
strLaw="aden*PRPP^fden1*IMP^fden2*ATP^fden4*GTP^fden8*Pi^fden18"
),

list( id="dgnuc", reversible=FALSE,
reactants=c("dGTP"),
products=c("Gua"),
parameters=c(adgnuc = 0.03333,fdgnuc10 = 1),
strLaw="adgnuc*dGTP^fdgnuc10"
),

list( id="dnaa", reversible=FALSE,
reactants=c("DNA"),
products=c("dATP"),
parameters=c(adnaa = 0.001938,fdnan12 = 1),
strLaw="adnaa*DNA^fdnan12"
),

list( id="dnag", reversible=FALSE,
reactants=c("DNA"),
products=c("dGTP"),
parameters=c(adnag = 0.001318,fdnan12 = 1),
strLaw="adnag*DNA^fdnan12"
),

list( id="gdna", reversible=FALSE,
reactants=c("dGTP"),
modifiers=c("dATP"),
products=c("DNA"),
parameters=c(agdna = 2.2296,fdnap9 = 0.42,fdnap10 = 0.33),
strLaw="agdna*dATP^fdnap9*dGTP^fdnap10"
),

list( id="gdrnr", reversible=FALSE,
reactants=c("GTP"),
modifiers=c("dATP","dGTP"),
products=c("dGTP"),
parameters=c(agdrnr = 0.1199,fgdrnr8 = 0.4,fgdrnr9 = -1.2,fgdrnr10 = -0.39),
strLaw="agdrnr*GTP^fgdrnr8*dATP^fgdrnr9*dGTP^fgdrnr10"
),

list( id="gmpr", reversible=FALSE,
reactants=c("GTP"),
modifiers=c("XMP","ATP","IMP"),
products=c("IMP"),
parameters=c(agmpr = 0.3005,fgmpr2 = -0.15,fgmpr4 = -0.07,fgmpr7 = -0.76,fgmpr8 = 0.7),
strLaw="agmpr*IMP^fgmpr2*ATP^fgmpr4*XMP^fgmpr7*GTP^fgmpr8"
),

list( id="gmps", reversible=FALSE,
reactants=c("XMP"),
modifiers=c("ATP"),
products=c("GTP"),
parameters=c(agmps = 0.3738,fgmps4 = 0.12,fgmps7 = 0.16),
strLaw="agmps*ATP^fgmps4*XMP^fgmps7"
),

list( id="gnuc", reversible=FALSE,
reactants=c("GTP"),
modifiers=c("Pi"),
products=c("Gua"),
parameters=c(agnuc = 0.2511,fgnuc8 = 0.9,fgnuc18 = -0.34),
strLaw="agnuc*GTP^fgnuc8*Pi^fgnuc18"
),

list( id="gprt", reversible=FALSE,
reactants=c("Gua","PRPP"),
modifiers=c("GTP"),
products=c("GTP"),
parameters=c(agprt = 361.69,fgprt1 = 1.2,fgprt8 = -1.2,fgprt15 = 0.42),
strLaw="agprt*PRPP^fgprt1*GTP^fgprt8*Gua^fgprt15"
),

list( id="grna", reversible=FALSE,
reactants=c("GTP"),
modifiers=c("ATP"),
products=c("RNA"),
parameters=c(agrna = 409.6,frnap4 = 0.05,frnap8 = 0.13),
strLaw="agrna*ATP^frnap4*GTP^frnap8"
),

list( id="gua", reversible=FALSE,
reactants=c("Gua"),
products=c("Xa"),
parameters=c(agua = 0.4919,fgua15 = 0.5),
strLaw="agua*Gua^fgua15"
),

list( id="hprt", reversible=FALSE,
reactants=c("HX","PRPP"),
modifiers=c("IMP"),
products=c("IMP"),
parameters=c(ahprt = 12.569,fhprt1 = 1.1,fhprt2 = -0.89,fhprt13 = 0.48),
strLaw="ahprt*PRPP^fhprt1*IMP^fhprt2*HX^fhprt13"
),

list( id="hx", reversible=FALSE,
reactants=c("HX"),
parameters=c(ahx = 0.003793,fhx13 = 1.12),
strLaw="ahx*HX^fhx13"
),

list( id="hxd", reversible=FALSE,
reactants=c("HX"),
products=c("Xa"),
parameters=c(ahxd = 0.2754,fhxd13 = 0.65),
strLaw="ahxd*HX^fhxd13"
),

list( id="impd", reversible=FALSE,
reactants=c("IMP"),
modifiers=c("GTP","XMP"),
products=c("XMP"),
parameters=c(aimpd = 1.2823,fimpd2 = 0.15,fimpd7 = -0.09,fimpd8 = -0.03),
strLaw="aimpd*IMP^fimpd2*XMP^fimpd7*GTP^fimpd8"
),

list( id="inuc", reversible=FALSE,
reactants=c("IMP"),
modifiers=c("Pi"),
products=c("HX"),
parameters=c(ainuc = 0.9135,finuc2 = 0.8,finuc18 = -0.36),
strLaw="ainuc*IMP^finuc2*Pi^finuc18"
),

list( id="mat", reversible=FALSE,
reactants=c("ATP"),
modifiers=c("SAM"),
products=c("SAM"),
parameters=c(amat = 7.2067,fmat4 = 0.2,fmat5 = -0.6),
strLaw="amat*ATP^fmat4*SAM^fmat5"
),

list( id="polyam", reversible=FALSE,
reactants=c("SAM"),
products=c("Ade"),
parameters=c(apolyam = 0.29,fpolyam5 = 0.9),
strLaw="apolyam*SAM^fpolyam5"
),

list( id="prpps", reversible=FALSE,
reactants=c("R5P"),
modifiers=c("ATP","GTP","Pi","PRPP"),
products=c("PRPP"),
parameters=c(aprpps = 0.9,fprpps1 = -0.03,fprpps4 = -0.45,fprpps8 = -0.04,fprpps17 = 0.65,fprpps18 = 0.7),
strLaw="aprpps*PRPP^fprpps1*ATP^fprpps4*GTP^fprpps8*R5P^fprpps17*Pi^fprpps18"
),

list( id="pyr", reversible=FALSE,
reactants=c("PRPP"),
parameters=c(apyr = 1.2951,fpyr1 = 1.27),
strLaw="apyr*PRPP^fpyr1"
),

list( id="rnaa", reversible=FALSE,
reactants=c("RNA"),
products=c("ATP"),
parameters=c(arnaa = 0.06923,frnan11 = 1),
strLaw="arnaa*RNA^frnan11"
),

list( id="rnag", reversible=FALSE,
reactants=c("RNA"),
products=c("GTP"),
parameters=c(arnag = 0.04615,frnan11 = 1),
strLaw="arnag*RNA^frnan11"
),

list( id="trans", reversible=FALSE,
reactants=c("SAM"),
products=c("ATP"),
parameters=c(atrans = 8.8539,ftrans5 = 0.33),
strLaw="atrans*SAM^ftrans5"
),

list( id="ua", reversible=FALSE,
reactants=c("UA"),
parameters=c(aua = 8.744e-005,fua16 = 2.21),
strLaw="aua*UA^fua16"
),

list( id="x", reversible=FALSE,
reactants=c("Xa"),
parameters=c(ax = 0.0012,fx14 = 2),
strLaw="ax*Xa^fx14"
),

list( id="xd", reversible=FALSE,
reactants=c("Xa"),
products=c("UA"),
parameters=c(axd = 0.949,fxd14 = 0.55),
strLaw="axd*Xa^fxd14"
))

)  

\documentclass[english]{article}

\begin{document}
\title{Quick Intro to SBMLR}
%\VignetteIndexEntry{Quick intro to SBMLR}
\author{Tom Radivoyevitch}

\maketitle

\section*{Introduction}
\emph{SBMLR} reads SBML files to and from an SBML-like R list of lists core object of class SBML, and it reads and writes 
these core objects into R text files that are well structured and light weight for editing. It also facilitates model
simulations and model summaries. 


\section*{Model import, export, editing and viewing}

The following code reads in Curto et al.'s purine metabolism model of 1998
<<read>>=
library(SBMLR)
curto=readSBML(system.file("models", "curto.xml", package = "SBMLR"))  
head(summary(curto)$reactions)
@
and the next two lines serialize the object curto of S3 class SBML (R list of lists) into a
current working directory SBML (XML) file and editable R code SBMLR file. 
Relative to the option of using \textit{dput} and \textit{deparse}, 
\textit{saveSBMLR} and \textit{readSBMLR} ASCII text representations are 
more pleasant to look at and thus edit (the carriage returns are in the right places). 
<<save>>=
saveSBML(curto,"curto.xml")
saveSBMLR(curto,"curto.r")
@
These two files can then be read back in and compared as follows.
<<equality>>=
curtoX=readSBML("curto.xml")
curtoR=readSBMLR("curto.r")
head((curtoX==curtoR)$species)
head((curtoX==curtoR)$reactions)
@
Values in these two dataframes are TRUE where the initial concentrations, fluxes, and reaction rate laws 
(as strings) are equal. 

\section*{Model simulation}
The following simulation first shows that the initial condition is a steady state. It then shows the  
time course response to an increase in [PRPP] from 5 uM to 50 uM. 
<<simulation>>=
out1=sim(curto,seq(-20,0,1))
curto$species$PRPP$ic=50
out2=sim(curto,0:70)
outs=data.frame(rbind(out1,out2))
attach(outs) 
par(mfrow=c(2,1))
plot(time,IMP,type="l",xlab="minutes",ylab="IMP (uM)")
plot(time,HX,type="l",xlab="minutes",ylab="HX (uM)")
par(mfrow=c(1,1))
detach(outs)
@

The modulator argument to \textit{sim} is either NULL, a vector of numbers, or a list of interpolation functions
(time varying enzyme concentration boundary conditions). The vector and list 
lengths are equal to the number of reactions; in the vector case reaction rate law amplitude parameters are multipied by 
1 at times less
than zero and the corresponding vector element thereafter. 
The following code doubles the amplitude parameters 
of Curto et al's 37 reactions at t=0; concentrations
then stay the same as fluxes double. 
<<bumpLessXfer>>=
curto$species$PRPP$ic=5  # return PRPP IC to its original value
sim(curto,(-10):10,modulator=rep(2,37)) # bumpless transfer in concentrations since all V increase by 2
@
If half the fluxes increase and the other half decrease, both by 10 percent, both concentrations and fluxes 
change 
<<unstable>>=
sim(curto,(-10):10,modulator=c(rep(1.1,20),rep(0.9,17))) # half up, half down, not bumpless
@
Clearly, this system has stability sensitivity problems. 

The folate model of Morrison and Allegra (JBC 1989) can be simulated as follows
<<folateSim>>=
morr=readSBML(file.path(system.file(package="SBMLR"), "models/morrison.xml"))  
out1=sim(morr,seq(-20,0,1))
morr$species$EMTX$ic=1 # bolus of methotrexate to 1 uM
out2=sim(morr,0:30)
outs=data.frame(rbind(out1,out2))
attach(outs)
par(mfrow=c(3,4))
plot(time,FH2b,type="l",xlab="Hours")
plot(time,FH2f,type="l",xlab="Hours")
plot(time,DHFRf,type="l",xlab="Hours")
plot(time,DHFRtot,type="l",xlab="Hours")
plot(time,CHOFH4,type="l",xlab="Hours")
plot(time,FH4,type="l",xlab="Hours")
plot(time,CH2FH4,type="l",xlab="Hours")
plot(time,CH3FH4,type="l",xlab="Hours")
plot(time,AICARsyn,type="l",xlab="Hours")
plot(time,MTR,type="l",xlab="Hours")
plot(time,TYMS,type="l",xlab="Hours")
#plot(time,EMTX,type="l",xlab="Hours")
plot(time,DHFReductase,type="l",xlab="Hours")
par(mfrow=c(1,1))
detach(outs)
@

As final outputs in this document, the full curto summary and 
object are:
<<summaryDump>>=
summary(curto)
curto
@



\end{document}
